Bug 58512

Summary: Calls to WebCore::Document::mayCauseFlashOfUnstyledContent make frequently-run drawing methods slower
Product: WebKit Reporter: Ian Henderson <ian>
Component: WebCore Misc.Assignee: Nobody <webkit-unassigned>
Status: RESOLVED FIXED    
Severity: Normal CC: ap, ddkilzer, hyatt, morrita, psolanki, simon.fraser
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Macintosh Intel   
OS: OS X 10.6   
Attachments:
Description Flags
Patch simon.fraser: review+

Description Ian Henderson 2011-04-13 21:58:37 PDT
In https://bugs.webkit.org/show_bug.cgi?id=45640, we added a more complicated heuristic to determine whether drawing may cause a flash of unstyled content.  The WebCore::Document::mayCauseFlashOfUnstyledContent method is called during every WebCore::RenderBlock::paintContents and WebCore::RenderLayer::paintLayer, both of which may be called many times on a complex page.  The additional complexity adds measurable overhead to these methods.
Comment 1 Hajime Morrita 2011-04-14 09:59:27 PDT
Okay, I'll remove mayCauseFlashOfUnstyledContent() usage.
I'd like to keep mayCauseFlashOfUnstyledContent() definition to possibly use it
on browser's paint() side, instead of preventing repaint() as we are doing now.
Comment 2 Hajime Morrita 2011-04-15 17:29:23 PDT
Created attachment 89891 [details]
Patch
Comment 3 Hajime Morrita 2011-04-15 17:29:59 PDT
I changed my mind to just roll it out.
Comment 4 Hajime Morrita 2011-04-15 17:49:36 PDT
Committed r84066: <http://trac.webkit.org/changeset/84066>